Index: /branches/cr/src/lib/collision_detection/Makefile.am
===================================================================
--- /branches/cr/src/lib/collision_detection/Makefile.am	(revision 7934)
+++ /branches/cr/src/lib/collision_detection/Makefile.am	(revision 7935)
@@ -5,5 +5,4 @@
 
 libORXcd_a_SOURCES = cd_engine.cc \
-                     collision.cc \
                      obb.cc \
                      obb_tree.cc \
@@ -17,5 +16,4 @@
 noinst_HEADERS =     cd_engine.h \
                      collision_defs.h \
-                     collision.h \
                      obb.h \
                      obb_tree.h \
Index: anches/cr/src/lib/collision_detection/collision.cc
===================================================================
--- /branches/cr/src/lib/collision_detection/collision.cc	(revision 7934)
+++ 	(revision )
@@ -1,37 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Patrick Boenzli
-   co-programmer: ...
-*/
-
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
-
-#include "collision.h"
-
-using namespace std;
-
-
-/**
- *  standard constructor
-*/
-Collision::Collision ()
-{
-}
-
-
-/**
- *  standard deconstructor
-
-*/
-Collision::~Collision ()
-{
-}
Index: anches/cr/src/lib/collision_detection/collision.h
===================================================================
--- /branches/cr/src/lib/collision_detection/collision.h	(revision 7934)
+++ 	(revision )
@@ -1,32 +1,0 @@
-/*!
- * @file collision.h
- *  Definition of a collision event
- */
-
-#ifndef _COLLISION_H
-#define _COLLISION_H
-
-#include "vector.h"
-
-class WorldEntity;
-class BoundingVolume;
-
-
-//! A class representing a simple collision
-class Collision {
-
- public:
-  Collision();
-  virtual ~Collision();
-
-
-
- private:
-  WorldEntity*      entityA;                       //!< the collision body A
-  WorldEntity*      entityB;                       //!< the collision body B
-
-  BoundingVolume*   bvA;                          //!< reference to the bounding volume A
-  BoundingVolume*   bvB;                          //!< reference to the bounding volume B
-};
-
-#endif /* _COLLISION_H */
Index: /branches/cr/src/lib/collision_reaction/Makefile.am
===================================================================
--- /branches/cr/src/lib/collision_reaction/Makefile.am	(revision 7934)
+++ /branches/cr/src/lib/collision_reaction/Makefile.am	(revision 7935)
@@ -5,4 +5,5 @@
 
 libORXcr_a_SOURCES = cr_engine.cc \
+                     collision.cc \
                      collision_handle.cc
 
@@ -10,4 +11,5 @@
 
 noinst_HEADERS =     cr_engine.h \
+                     collision.h \
                      collision_handle.h
 
Index: /branches/cr/src/lib/collision_reaction/collision.cc
===================================================================
--- /branches/cr/src/lib/collision_reaction/collision.cc	(revision 7935)
+++ /branches/cr/src/lib/collision_reaction/collision.cc	(revision 7935)
@@ -0,0 +1,37 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
+
+#include "collision.h"
+
+using namespace std;
+
+
+/**
+ *  standard constructor
+*/
+Collision::Collision ()
+{
+}
+
+
+/**
+ *  standard deconstructor
+
+*/
+Collision::~Collision ()
+{
+}
Index: /branches/cr/src/lib/collision_reaction/collision.h
===================================================================
--- /branches/cr/src/lib/collision_reaction/collision.h	(revision 7935)
+++ /branches/cr/src/lib/collision_reaction/collision.h	(revision 7935)
@@ -0,0 +1,32 @@
+/*!
+ * @file collision.h
+ *  Definition of a collision event
+ */
+
+#ifndef _COLLISION_H
+#define _COLLISION_H
+
+#include "vector.h"
+
+class WorldEntity;
+class BoundingVolume;
+
+
+//! A class representing a simple collision
+class Collision {
+
+ public:
+  Collision();
+  virtual ~Collision();
+
+
+
+ private:
+  WorldEntity*      entityA;                       //!< the collision body A
+  WorldEntity*      entityB;                       //!< the collision body B
+
+  BoundingVolume*   bvA;                          //!< reference to the bounding volume A
+  BoundingVolume*   bvB;                          //!< reference to the bounding volume B
+};
+
+#endif /* _COLLISION_H */